#include <ell/CRNAFreeEnergySingleMoveStructState.hh>
#include <fstream>	// for readBinaryInputClone(..)

namespace ell
{

	CRNAFreeEnergySingleMoveStructState::CRNAFreeEnergySingleMoveStructState(
	 const Structure& struc) {
		cStructure = compressSeq(struc, RNAFreeEnergy::getStructureAlphabet());
	}

	CRNAFreeEnergySingleMoveStructState::
	~CRNAFreeEnergySingleMoveStructState() {
	}

	std::string
	CRNAFreeEnergySingleMoveStructState::getUncompressedSeqStr() const {
		return RNAFreeEnergySingleMoveStructState::getCommonSequenceString();
	}

	std::string
	CRNAFreeEnergySingleMoveStructState::getUncompressedStructStr() const {
		return uncompressSeq(cStructure,RNAFreeEnergy::getStructureAlphabet(),
							  RNAFreeEnergySingleMoveStructState::
							  getCommonSequenceString().size());
	}

	bool	
	CRNAFreeEnergySingleMoveStructState::operator== (const CState& _cState2) const {
		CRNAFreeEnergySingleMoveStructState cState2 =
		 dynamic_cast<const CRNAFreeEnergySingleMoveStructState&>(_cState2);
		return this->cStructure == cState2.cStructure;
	}

	bool	
	CRNAFreeEnergySingleMoveStructState::operator!= (const CState& _cState2) const {
		CRNAFreeEnergySingleMoveStructState cState2 =
		 dynamic_cast<const CRNAFreeEnergySingleMoveStructState&>(_cState2);
		return this->cStructure != cState2.cStructure;
	}

	CRNAFreeEnergySingleMoveStructState* 
	CRNAFreeEnergySingleMoveStructState::clone() const {
		return new CRNAFreeEnergySingleMoveStructState(*this);
	}

	std::string
	CRNAFreeEnergySingleMoveStructState::getCStateStringRepresentation()
	 const {
		std::string strRepr;
		for (size_t i = 0; i < cStructure.size(); i++) {
			strRepr += cStructure[i];
		}
		return strRepr;
	}

	std::string
	CRNAFreeEnergySingleMoveStructState::getUncomprStateStringRepresentation()
	 const {
		return getUncompressedStructStr();
	}

	State*
	CRNAFreeEnergySingleMoveStructState::uncompressedClone() const {
		return new RNAFreeEnergySingleMoveStructState(
					 getUncompressedStructStr());
	}

	void
	CRNAFreeEnergySingleMoveStructState::uncompress(State& state) const {
		dynamic_cast<RNAFreeEnergySingleMoveStructState&>(state) =
		 RNAFreeEnergySingleMoveStructState(getUncompressedStructStr());
	}

	CRNAFreeEnergySingleMoveStructState*
	CRNAFreeEnergySingleMoveStructState::readBinaryInputClone (
	 std::ifstream& source) const {

			// create new CRNAFreeEnergySingleMoveStructState
		CRNAFreeEnergySingleMoveStructState* cState =
		 new CRNAFreeEnergySingleMoveStructState();

		size_t size;

			// read cStructure
		source.read(reinterpret_cast<char*>(&size), sizeof(size));
		cState->cStructure.resize(size);
		for (size_t i = 0; i < cState->cStructure.size(); i++) {
			source.read(reinterpret_cast<char*>(&(cState->cStructure[i])),
						  sizeof(cState->cStructure[i]));
		}

		return cState;
	}

	void
	CRNAFreeEnergySingleMoveStructState::writeBinaryOutput(
	 std::ofstream& destination) const {
			// write cStructure
		size_t size = cStructure.size();
		destination.write(reinterpret_cast<const char*>(&size), sizeof(size));
		for (size_t i = 0; i < size; i++) {
			destination.write(reinterpret_cast<const char*>(&(cStructure[i])),
							   sizeof(cStructure[i]));
		}
	}

} // namespace ell
